// Copyright 2023-2025 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.36.5
// 	protoc        (unknown)
// source: buf/registry/policy/v1beta1/policy.proto

//go:build protoopaque

package policyv1beta1

import (
	_ "buf.build/gen/go/bufbuild/protovalidate/protocolbuffers/go/buf/validate"
	_ "buf.build/gen/go/bufbuild/registry/protocolbuffers/go/buf/registry/priv/extension/v1beta1"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	reflect "reflect"
	unsafe "unsafe"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// The visibility of a Policy, currently either public or private.
type PolicyVisibility int32

const (
	PolicyVisibility_POLICY_VISIBILITY_UNSPECIFIED PolicyVisibility = 0
	// POLICY_VISIBILITY_PUBLIC says that the Policy is publicly available.
	PolicyVisibility_POLICY_VISIBILITY_PUBLIC PolicyVisibility = 1
	// POLICY_VISIBILITY_PRIVATE says that the Policy is private.
	PolicyVisibility_POLICY_VISIBILITY_PRIVATE PolicyVisibility = 2
)

// Enum value maps for PolicyVisibility.
var (
	PolicyVisibility_name = map[int32]string{
		0: "POLICY_VISIBILITY_UNSPECIFIED",
		1: "POLICY_VISIBILITY_PUBLIC",
		2: "POLICY_VISIBILITY_PRIVATE",
	}
	PolicyVisibility_value = map[string]int32{
		"POLICY_VISIBILITY_UNSPECIFIED": 0,
		"POLICY_VISIBILITY_PUBLIC":      1,
		"POLICY_VISIBILITY_PRIVATE":     2,
	}
)

func (x PolicyVisibility) Enum() *PolicyVisibility {
	p := new(PolicyVisibility)
	*p = x
	return p
}

func (x PolicyVisibility) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (PolicyVisibility) Descriptor() protoreflect.EnumDescriptor {
	return file_buf_registry_policy_v1beta1_policy_proto_enumTypes[0].Descriptor()
}

func (PolicyVisibility) Type() protoreflect.EnumType {
	return &file_buf_registry_policy_v1beta1_policy_proto_enumTypes[0]
}

func (x PolicyVisibility) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// The state of a Policy, currently either active or deprecated.
type PolicyState int32

const (
	PolicyState_POLICY_STATE_UNSPECIFIED PolicyState = 0
	// POLICY_STATE_ACTIVE says that the Policy is currently active.
	PolicyState_POLICY_STATE_ACTIVE PolicyState = 1
	// POLICY_STATE_DEPRECATED says that the Policy has been deprecated and should not longer be
	// used.
	PolicyState_POLICY_STATE_DEPRECATED PolicyState = 2
)

// Enum value maps for PolicyState.
var (
	PolicyState_name = map[int32]string{
		0: "POLICY_STATE_UNSPECIFIED",
		1: "POLICY_STATE_ACTIVE",
		2: "POLICY_STATE_DEPRECATED",
	}
	PolicyState_value = map[string]int32{
		"POLICY_STATE_UNSPECIFIED": 0,
		"POLICY_STATE_ACTIVE":      1,
		"POLICY_STATE_DEPRECATED":  2,
	}
)

func (x PolicyState) Enum() *PolicyState {
	p := new(PolicyState)
	*p = x
	return p
}

func (x PolicyState) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (PolicyState) Descriptor() protoreflect.EnumDescriptor {
	return file_buf_registry_policy_v1beta1_policy_proto_enumTypes[1].Descriptor()
}

func (PolicyState) Type() protoreflect.EnumType {
	return &file_buf_registry_policy_v1beta1_policy_proto_enumTypes[1]
}

func (x PolicyState) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// A policy within the BSR.
type Policy struct {
	state                 protoimpl.MessageState `protogen:"opaque.v1"`
	xxx_hidden_Id         string                 `protobuf:"bytes,1,opt,name=id,proto3"`
	xxx_hidden_CreateTime *timestamppb.Timestamp `protobuf:"bytes,2,opt,name=create_time,json=createTime,proto3"`
	xxx_hidden_UpdateTime *timestamppb.Timestamp `protobuf:"bytes,3,opt,name=update_time,json=updateTime,proto3"`
	xxx_hidden_Name       string                 `protobuf:"bytes,4,opt,name=name,proto3"`
	xxx_hidden_OwnerId    string                 `protobuf:"bytes,5,opt,name=owner_id,json=ownerId,proto3"`
	xxx_hidden_Visibility PolicyVisibility       `protobuf:"varint,6,opt,name=visibility,proto3,enum=buf.registry.policy.v1beta1.PolicyVisibility"`
	xxx_hidden_State      PolicyState            `protobuf:"varint,7,opt,name=state,proto3,enum=buf.registry.policy.v1beta1.PolicyState"`
	xxx_hidden_Desription string                 `protobuf:"bytes,8,opt,name=desription,proto3"`
	unknownFields         protoimpl.UnknownFields
	sizeCache             protoimpl.SizeCache
}

func (x *Policy) Reset() {
	*x = Policy{}
	mi := &file_buf_registry_policy_v1beta1_policy_proto_msgTypes[0]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Policy) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Policy) ProtoMessage() {}

func (x *Policy) ProtoReflect() protoreflect.Message {
	mi := &file_buf_registry_policy_v1beta1_policy_proto_msgTypes[0]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

func (x *Policy) GetId() string {
	if x != nil {
		return x.xxx_hidden_Id
	}
	return ""
}

func (x *Policy) GetCreateTime() *timestamppb.Timestamp {
	if x != nil {
		return x.xxx_hidden_CreateTime
	}
	return nil
}

func (x *Policy) GetUpdateTime() *timestamppb.Timestamp {
	if x != nil {
		return x.xxx_hidden_UpdateTime
	}
	return nil
}

func (x *Policy) GetName() string {
	if x != nil {
		return x.xxx_hidden_Name
	}
	return ""
}

func (x *Policy) GetOwnerId() string {
	if x != nil {
		return x.xxx_hidden_OwnerId
	}
	return ""
}

func (x *Policy) GetVisibility() PolicyVisibility {
	if x != nil {
		return x.xxx_hidden_Visibility
	}
	return PolicyVisibility_POLICY_VISIBILITY_UNSPECIFIED
}

func (x *Policy) GetState() PolicyState {
	if x != nil {
		return x.xxx_hidden_State
	}
	return PolicyState_POLICY_STATE_UNSPECIFIED
}

func (x *Policy) GetDesription() string {
	if x != nil {
		return x.xxx_hidden_Desription
	}
	return ""
}

func (x *Policy) SetId(v string) {
	x.xxx_hidden_Id = v
}

func (x *Policy) SetCreateTime(v *timestamppb.Timestamp) {
	x.xxx_hidden_CreateTime = v
}

func (x *Policy) SetUpdateTime(v *timestamppb.Timestamp) {
	x.xxx_hidden_UpdateTime = v
}

func (x *Policy) SetName(v string) {
	x.xxx_hidden_Name = v
}

func (x *Policy) SetOwnerId(v string) {
	x.xxx_hidden_OwnerId = v
}

func (x *Policy) SetVisibility(v PolicyVisibility) {
	x.xxx_hidden_Visibility = v
}

func (x *Policy) SetState(v PolicyState) {
	x.xxx_hidden_State = v
}

func (x *Policy) SetDesription(v string) {
	x.xxx_hidden_Desription = v
}

func (x *Policy) HasCreateTime() bool {
	if x == nil {
		return false
	}
	return x.xxx_hidden_CreateTime != nil
}

func (x *Policy) HasUpdateTime() bool {
	if x == nil {
		return false
	}
	return x.xxx_hidden_UpdateTime != nil
}

func (x *Policy) ClearCreateTime() {
	x.xxx_hidden_CreateTime = nil
}

func (x *Policy) ClearUpdateTime() {
	x.xxx_hidden_UpdateTime = nil
}

type Policy_builder struct {
	_ [0]func() // Prevents comparability and use of unkeyed literals for the builder.

	// The id of the Policy.
	Id string
	// The time the Policy was created in the BSR.
	CreateTime *timestamppb.Timestamp
	// The last time the Policy was updated on the BSR.
	UpdateTime *timestamppb.Timestamp
	// The name of the Policy.
	//
	// Unique within a given Organization.
	Name string
	// The id of the Organization that owns the Policy.
	OwnerId string
	// The Policy's visibility, either public or private.
	Visibility PolicyVisibility
	// The Policy state, either active or deprecated.
	State PolicyState
	// The configurable description of the Policy.
	Desription string
}

func (b0 Policy_builder) Build() *Policy {
	m0 := &Policy{}
	b, x := &b0, m0
	_, _ = b, x
	x.xxx_hidden_Id = b.Id
	x.xxx_hidden_CreateTime = b.CreateTime
	x.xxx_hidden_UpdateTime = b.UpdateTime
	x.xxx_hidden_Name = b.Name
	x.xxx_hidden_OwnerId = b.OwnerId
	x.xxx_hidden_Visibility = b.Visibility
	x.xxx_hidden_State = b.State
	x.xxx_hidden_Desription = b.Desription
	return m0
}

// PolicyRef is a reference to a Policy, either an id or a fully-qualified name.
//
// This is used in requests.
type PolicyRef struct {
	state            protoimpl.MessageState `protogen:"opaque.v1"`
	xxx_hidden_Value isPolicyRef_Value      `protobuf_oneof:"value"`
	unknownFields    protoimpl.UnknownFields
	sizeCache        protoimpl.SizeCache
}

func (x *PolicyRef) Reset() {
	*x = PolicyRef{}
	mi := &file_buf_registry_policy_v1beta1_policy_proto_msgTypes[1]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *PolicyRef) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PolicyRef) ProtoMessage() {}

func (x *PolicyRef) ProtoReflect() protoreflect.Message {
	mi := &file_buf_registry_policy_v1beta1_policy_proto_msgTypes[1]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

func (x *PolicyRef) GetId() string {
	if x != nil {
		if x, ok := x.xxx_hidden_Value.(*policyRef_Id); ok {
			return x.Id
		}
	}
	return ""
}

func (x *PolicyRef) GetName() *PolicyRef_Name {
	if x != nil {
		if x, ok := x.xxx_hidden_Value.(*policyRef_Name_); ok {
			return x.Name
		}
	}
	return nil
}

func (x *PolicyRef) SetId(v string) {
	x.xxx_hidden_Value = &policyRef_Id{v}
}

func (x *PolicyRef) SetName(v *PolicyRef_Name) {
	if v == nil {
		x.xxx_hidden_Value = nil
		return
	}
	x.xxx_hidden_Value = &policyRef_Name_{v}
}

func (x *PolicyRef) HasValue() bool {
	if x == nil {
		return false
	}
	return x.xxx_hidden_Value != nil
}

func (x *PolicyRef) HasId() bool {
	if x == nil {
		return false
	}
	_, ok := x.xxx_hidden_Value.(*policyRef_Id)
	return ok
}

func (x *PolicyRef) HasName() bool {
	if x == nil {
		return false
	}
	_, ok := x.xxx_hidden_Value.(*policyRef_Name_)
	return ok
}

func (x *PolicyRef) ClearValue() {
	x.xxx_hidden_Value = nil
}

func (x *PolicyRef) ClearId() {
	if _, ok := x.xxx_hidden_Value.(*policyRef_Id); ok {
		x.xxx_hidden_Value = nil
	}
}

func (x *PolicyRef) ClearName() {
	if _, ok := x.xxx_hidden_Value.(*policyRef_Name_); ok {
		x.xxx_hidden_Value = nil
	}
}

const PolicyRef_Value_not_set_case case_PolicyRef_Value = 0
const PolicyRef_Id_case case_PolicyRef_Value = 1
const PolicyRef_Name_case case_PolicyRef_Value = 2

func (x *PolicyRef) WhichValue() case_PolicyRef_Value {
	if x == nil {
		return PolicyRef_Value_not_set_case
	}
	switch x.xxx_hidden_Value.(type) {
	case *policyRef_Id:
		return PolicyRef_Id_case
	case *policyRef_Name_:
		return PolicyRef_Name_case
	default:
		return PolicyRef_Value_not_set_case
	}
}

type PolicyRef_builder struct {
	_ [0]func() // Prevents comparability and use of unkeyed literals for the builder.

	// Fields of oneof xxx_hidden_Value:
	// The id of the Policy.
	Id *string
	// The full-qualified name of the Policy.
	Name *PolicyRef_Name
	// -- end of xxx_hidden_Value
}

func (b0 PolicyRef_builder) Build() *PolicyRef {
	m0 := &PolicyRef{}
	b, x := &b0, m0
	_, _ = b, x
	if b.Id != nil {
		x.xxx_hidden_Value = &policyRef_Id{*b.Id}
	}
	if b.Name != nil {
		x.xxx_hidden_Value = &policyRef_Name_{b.Name}
	}
	return m0
}

type case_PolicyRef_Value protoreflect.FieldNumber

func (x case_PolicyRef_Value) String() string {
	md := file_buf_registry_policy_v1beta1_policy_proto_msgTypes[1].Descriptor()
	if x == 0 {
		return "not set"
	}
	return protoimpl.X.MessageFieldStringOf(md, protoreflect.FieldNumber(x))
}

type isPolicyRef_Value interface {
	isPolicyRef_Value()
}

type policyRef_Id struct {
	// The id of the Policy.
	Id string `protobuf:"bytes,1,opt,name=id,proto3,oneof"`
}

type policyRef_Name_ struct {
	// The full-qualified name of the Policy.
	Name *PolicyRef_Name `protobuf:"bytes,2,opt,name=name,proto3,oneof"`
}

func (*policyRef_Id) isPolicyRef_Value() {}

func (*policyRef_Name_) isPolicyRef_Value() {}

// The fully-qualified name of a Policy within a BSR intance.
//
// A Name uniquely identifies a Policy.
// This is used for requests when a caller only has the policy name and not the ID.
type PolicyRef_Name struct {
	state             protoimpl.MessageState `protogen:"opaque.v1"`
	xxx_hidden_Owner  string                 `protobuf:"bytes,1,opt,name=owner,proto3"`
	xxx_hidden_Policy string                 `protobuf:"bytes,2,opt,name=policy,proto3"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *PolicyRef_Name) Reset() {
	*x = PolicyRef_Name{}
	mi := &file_buf_registry_policy_v1beta1_policy_proto_msgTypes[2]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *PolicyRef_Name) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PolicyRef_Name) ProtoMessage() {}

func (x *PolicyRef_Name) ProtoReflect() protoreflect.Message {
	mi := &file_buf_registry_policy_v1beta1_policy_proto_msgTypes[2]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

func (x *PolicyRef_Name) GetOwner() string {
	if x != nil {
		return x.xxx_hidden_Owner
	}
	return ""
}

func (x *PolicyRef_Name) GetPolicy() string {
	if x != nil {
		return x.xxx_hidden_Policy
	}
	return ""
}

func (x *PolicyRef_Name) SetOwner(v string) {
	x.xxx_hidden_Owner = v
}

func (x *PolicyRef_Name) SetPolicy(v string) {
	x.xxx_hidden_Policy = v
}

type PolicyRef_Name_builder struct {
	_ [0]func() // Prevents comparability and use of unkeyed literals for the builder.

	// The name of the owner of the Policy. The owner is always an Organization.
	Owner string
	// The name of the Policy.
	Policy string
}

func (b0 PolicyRef_Name_builder) Build() *PolicyRef_Name {
	m0 := &PolicyRef_Name{}
	b, x := &b0, m0
	_, _ = b, x
	x.xxx_hidden_Owner = b.Owner
	x.xxx_hidden_Policy = b.Policy
	return m0
}

var File_buf_registry_policy_v1beta1_policy_proto protoreflect.FileDescriptor

var file_buf_registry_policy_v1beta1_policy_proto_rawDesc = string([]byte{
	0x0a, 0x28, 0x62, 0x75, 0x66, 0x2f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x72, 0x79, 0x2f, 0x70,
	0x6f, 0x6c, 0x69, 0x63, 0x79, 0x2f, 0x76, 0x31, 0x62, 0x65, 0x74, 0x61, 0x31, 0x2f, 0x70, 0x6f,
	0x6c, 0x69, 0x63, 0x79, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x1b, 0x62, 0x75, 0x66, 0x2e,
	0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x72, 0x79, 0x2e, 0x70, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x2e,
	0x76, 0x31, 0x62, 0x65, 0x74, 0x61, 0x31, 0x1a, 0x33, 0x62, 0x75, 0x66, 0x2f, 0x72, 0x65, 0x67,
	0x69, 0x73, 0x74, 0x72, 0x79, 0x2f, 0x70, 0x72, 0x69, 0x76, 0x2f, 0x65, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x2f, 0x76, 0x31, 0x62, 0x65, 0x74, 0x61, 0x31, 0x2f, 0x65, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a, 0x1b, 0x62, 0x75,
	0x66, 0x2f, 0x76, 0x61, 0x6c, 0x69, 0x64, 0x61, 0x74, 0x65, 0x2f, 0x76, 0x61, 0x6c, 0x69, 0x64,
	0x61, 0x74, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a, 0x1f, 0x67, 0x6f, 0x6f, 0x67, 0x6c,
	0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2f, 0x74, 0x69, 0x6d, 0x65, 0x73,
	0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0xd1, 0x03, 0x0a, 0x06, 0x50,
	0x6f, 0x6c, 0x69, 0x63, 0x79, 0x12, 0x1b, 0x0a, 0x02, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28,
	0x09, 0x42, 0x0b, 0xba, 0x48, 0x08, 0xc8, 0x01, 0x01, 0x72, 0x03, 0x88, 0x02, 0x01, 0x52, 0x02,
	0x69, 0x64, 0x12, 0x43, 0x0a, 0x0b, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x5f, 0x74, 0x69, 0x6d,
	0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65,
	0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74,
	0x61, 0x6d, 0x70, 0x42, 0x06, 0xba, 0x48, 0x03, 0xc8, 0x01, 0x01, 0x52, 0x0a, 0x63, 0x72, 0x65,
	0x61, 0x74, 0x65, 0x54, 0x69, 0x6d, 0x65, 0x12, 0x43, 0x0a, 0x0b, 0x75, 0x70, 0x64, 0x61, 0x74,
	0x65, 0x5f, 0x74, 0x69, 0x6d, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67,
	0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54,
	0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x42, 0x06, 0xba, 0x48, 0x03, 0xc8, 0x01, 0x01,
	0x52, 0x0a, 0x75, 0x70, 0x64, 0x61, 0x74, 0x65, 0x54, 0x69, 0x6d, 0x65, 0x12, 0x1d, 0x0a, 0x04,
	0x6e, 0x61, 0x6d, 0x65, 0x18, 0x04, 0x20, 0x01, 0x28, 0x09, 0x42, 0x09, 0xba, 0x48, 0x06, 0x72,
	0x04, 0x10, 0x02, 0x18, 0x64, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12, 0x26, 0x0a, 0x08, 0x6f,
	0x77, 0x6e, 0x65, 0x72, 0x5f, 0x69, 0x64, 0x18, 0x05, 0x20, 0x01, 0x28, 0x09, 0x42, 0x0b, 0xba,
	0x48, 0x08, 0xc8, 0x01, 0x01, 0x72, 0x03, 0x88, 0x02, 0x01, 0x52, 0x07, 0x6f, 0x77, 0x6e, 0x65,
	0x72, 0x49, 0x64, 0x12, 0x5a, 0x0a, 0x0a, 0x76, 0x69, 0x73, 0x69, 0x62, 0x69, 0x6c, 0x69, 0x74,
	0x79, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x2d, 0x2e, 0x62, 0x75, 0x66, 0x2e, 0x72, 0x65,
	0x67, 0x69, 0x73, 0x74, 0x72, 0x79, 0x2e, 0x70, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x2e, 0x76, 0x31,
	0x62, 0x65, 0x74, 0x61, 0x31, 0x2e, 0x50, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x56, 0x69, 0x73, 0x69,
	0x62, 0x69, 0x6c, 0x69, 0x74, 0x79, 0x42, 0x0b, 0xba, 0x48, 0x08, 0xc8, 0x01, 0x01, 0x82, 0x01,
	0x02, 0x10, 0x01, 0x52, 0x0a, 0x76, 0x69, 0x73, 0x69, 0x62, 0x69, 0x6c, 0x69, 0x74, 0x79, 0x12,
	0x4b, 0x0a, 0x05, 0x73, 0x74, 0x61, 0x74, 0x65, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x28,
	0x2e, 0x62, 0x75, 0x66, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x72, 0x79, 0x2e, 0x70, 0x6f,
	0x6c, 0x69, 0x63, 0x79, 0x2e, 0x76, 0x31, 0x62, 0x65, 0x74, 0x61, 0x31, 0x2e, 0x50, 0x6f, 0x6c,
	0x69, 0x63, 0x79, 0x53, 0x74, 0x61, 0x74, 0x65, 0x42, 0x0b, 0xba, 0x48, 0x08, 0xc8, 0x01, 0x01,
	0x82, 0x01, 0x02, 0x10, 0x01, 0x52, 0x05, 0x73, 0x74, 0x61, 0x74, 0x65, 0x12, 0x28, 0x0a, 0x0a,
	0x64, 0x65, 0x73, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x08, 0x20, 0x01, 0x28, 0x09,
	0x42, 0x08, 0xba, 0x48, 0x05, 0x72, 0x03, 0x18, 0xde, 0x02, 0x52, 0x0a, 0x64, 0x65, 0x73, 0x72,
	0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x3a, 0x06, 0xea, 0xc5, 0x2b, 0x02, 0x10, 0x01, 0x22, 0xcf,
	0x01, 0x0a, 0x09, 0x50, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x52, 0x65, 0x66, 0x12, 0x1a, 0x0a, 0x02,
	0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x42, 0x08, 0xba, 0x48, 0x05, 0x72, 0x03, 0x88,
	0x02, 0x01, 0x48, 0x00, 0x52, 0x02, 0x69, 0x64, 0x12, 0x41, 0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x62, 0x75, 0x66, 0x2e, 0x72, 0x65, 0x67,
	0x69, 0x73, 0x74, 0x72, 0x79, 0x2e, 0x70, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x2e, 0x76, 0x31, 0x62,
	0x65, 0x74, 0x61, 0x31, 0x2e, 0x50, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x52, 0x65, 0x66, 0x2e, 0x4e,
	0x61, 0x6d, 0x65, 0x48, 0x00, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x1a, 0x4b, 0x0a, 0x04, 0x4e,
	0x61, 0x6d, 0x65, 0x12, 0x20, 0x0a, 0x05, 0x6f, 0x77, 0x6e, 0x65, 0x72, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x09, 0x42, 0x0a, 0xba, 0x48, 0x07, 0xc8, 0x01, 0x01, 0x72, 0x02, 0x18, 0x20, 0x52, 0x05,
	0x6f, 0x77, 0x6e, 0x65, 0x72, 0x12, 0x21, 0x0a, 0x06, 0x70, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x09, 0x42, 0x09, 0xba, 0x48, 0x06, 0x72, 0x04, 0x10, 0x02, 0x18, 0x64,
	0x52, 0x06, 0x70, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x3a, 0x06, 0xea, 0xc5, 0x2b, 0x02, 0x08, 0x01,
	0x42, 0x0e, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x05, 0xba, 0x48, 0x02, 0x08, 0x01,
	0x2a, 0x72, 0x0a, 0x10, 0x50, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x56, 0x69, 0x73, 0x69, 0x62, 0x69,
	0x6c, 0x69, 0x74, 0x79, 0x12, 0x21, 0x0a, 0x1d, 0x50, 0x4f, 0x4c, 0x49, 0x43, 0x59, 0x5f, 0x56,
	0x49, 0x53, 0x49, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43,
	0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x1c, 0x0a, 0x18, 0x50, 0x4f, 0x4c, 0x49, 0x43,
	0x59, 0x5f, 0x56, 0x49, 0x53, 0x49, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x5f, 0x50, 0x55, 0x42,
	0x4c, 0x49, 0x43, 0x10, 0x01, 0x12, 0x1d, 0x0a, 0x19, 0x50, 0x4f, 0x4c, 0x49, 0x43, 0x59, 0x5f,
	0x56, 0x49, 0x53, 0x49, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x5f, 0x50, 0x52, 0x49, 0x56, 0x41,
	0x54, 0x45, 0x10, 0x02, 0x2a, 0x61, 0x0a, 0x0b, 0x50, 0x6f, 0x6c, 0x69, 0x63, 0x79, 0x53, 0x74,
	0x61, 0x74, 0x65, 0x12, 0x1c, 0x0a, 0x18, 0x50, 0x4f, 0x4c, 0x49, 0x43, 0x59, 0x5f, 0x53, 0x54,
	0x41, 0x54, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10,
	0x00, 0x12, 0x17, 0x0a, 0x13, 0x50, 0x4f, 0x4c, 0x49, 0x43, 0x59, 0x5f, 0x53, 0x54, 0x41, 0x54,
	0x45, 0x5f, 0x41, 0x43, 0x54, 0x49, 0x56, 0x45, 0x10, 0x01, 0x12, 0x1b, 0x0a, 0x17, 0x50, 0x4f,
	0x4c, 0x49, 0x43, 0x59, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x45, 0x5f, 0x44, 0x45, 0x50, 0x52, 0x45,
	0x43, 0x41, 0x54, 0x45, 0x44, 0x10, 0x02, 0x42, 0x61, 0x5a, 0x5f, 0x62, 0x75, 0x66, 0x2e, 0x62,
	0x75, 0x69, 0x6c, 0x64, 0x2f, 0x67, 0x65, 0x6e, 0x2f, 0x67, 0x6f, 0x2f, 0x62, 0x75, 0x66, 0x62,
	0x75, 0x69, 0x6c, 0x64, 0x2f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x72, 0x79, 0x2f, 0x70, 0x72,
	0x6f, 0x74, 0x6f, 0x63, 0x6f, 0x6c, 0x62, 0x75, 0x66, 0x66, 0x65, 0x72, 0x73, 0x2f, 0x67, 0x6f,
	0x2f, 0x62, 0x75, 0x66, 0x2f, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x72, 0x79, 0x2f, 0x70, 0x6f,
	0x6c, 0x69, 0x63, 0x79, 0x2f, 0x76, 0x31, 0x62, 0x65, 0x74, 0x61, 0x31, 0x3b, 0x70, 0x6f, 0x6c,
	0x69, 0x63, 0x79, 0x76, 0x31, 0x62, 0x65, 0x74, 0x61, 0x31, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74,
	0x6f, 0x33,
})

var file_buf_registry_policy_v1beta1_policy_proto_enumTypes = make([]protoimpl.EnumInfo, 2)
var file_buf_registry_policy_v1beta1_policy_proto_msgTypes = make([]protoimpl.MessageInfo, 3)
var file_buf_registry_policy_v1beta1_policy_proto_goTypes = []any{
	(PolicyVisibility)(0),         // 0: buf.registry.policy.v1beta1.PolicyVisibility
	(PolicyState)(0),              // 1: buf.registry.policy.v1beta1.PolicyState
	(*Policy)(nil),                // 2: buf.registry.policy.v1beta1.Policy
	(*PolicyRef)(nil),             // 3: buf.registry.policy.v1beta1.PolicyRef
	(*PolicyRef_Name)(nil),        // 4: buf.registry.policy.v1beta1.PolicyRef.Name
	(*timestamppb.Timestamp)(nil), // 5: google.protobuf.Timestamp
}
var file_buf_registry_policy_v1beta1_policy_proto_depIdxs = []int32{
	5, // 0: buf.registry.policy.v1beta1.Policy.create_time:type_name -> google.protobuf.Timestamp
	5, // 1: buf.registry.policy.v1beta1.Policy.update_time:type_name -> google.protobuf.Timestamp
	0, // 2: buf.registry.policy.v1beta1.Policy.visibility:type_name -> buf.registry.policy.v1beta1.PolicyVisibility
	1, // 3: buf.registry.policy.v1beta1.Policy.state:type_name -> buf.registry.policy.v1beta1.PolicyState
	4, // 4: buf.registry.policy.v1beta1.PolicyRef.name:type_name -> buf.registry.policy.v1beta1.PolicyRef.Name
	5, // [5:5] is the sub-list for method output_type
	5, // [5:5] is the sub-list for method input_type
	5, // [5:5] is the sub-list for extension type_name
	5, // [5:5] is the sub-list for extension extendee
	0, // [0:5] is the sub-list for field type_name
}

func init() { file_buf_registry_policy_v1beta1_policy_proto_init() }
func file_buf_registry_policy_v1beta1_policy_proto_init() {
	if File_buf_registry_policy_v1beta1_policy_proto != nil {
		return
	}
	file_buf_registry_policy_v1beta1_policy_proto_msgTypes[1].OneofWrappers = []any{
		(*policyRef_Id)(nil),
		(*policyRef_Name_)(nil),
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: unsafe.Slice(unsafe.StringData(file_buf_registry_policy_v1beta1_policy_proto_rawDesc), len(file_buf_registry_policy_v1beta1_policy_proto_rawDesc)),
			NumEnums:      2,
			NumMessages:   3,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_buf_registry_policy_v1beta1_policy_proto_goTypes,
		DependencyIndexes: file_buf_registry_policy_v1beta1_policy_proto_depIdxs,
		EnumInfos:         file_buf_registry_policy_v1beta1_policy_proto_enumTypes,
		MessageInfos:      file_buf_registry_policy_v1beta1_policy_proto_msgTypes,
	}.Build()
	File_buf_registry_policy_v1beta1_policy_proto = out.File
	file_buf_registry_policy_v1beta1_policy_proto_goTypes = nil
	file_buf_registry_policy_v1beta1_policy_proto_depIdxs = nil
}
